]> git.saurik.com Git - apt.git/blame - test/integration/framework
test: Use a file to determine TEST_DEFAULT_GROUP
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
5d76cee1 3EXIT_CODE=0
8c1dd12c 4
68042532
DK
5while [ -n "$1" ]; do
6 if [ "$1" = "-q" ]; then
7 export MSGLEVEL=2
8 elif [ "$1" = "-v" ]; then
9 export MSGLEVEL=4
10 elif [ "$1" = '--color=no' ]; then
11 export MSGCOLOR='NO'
61e92778
DK
12 elif [ "$1" = '--color=yes' ]; then
13 export MSGCOLOR='YES'
14 elif [ "$1" = '--color' ]; then
15 export MSGCOLOR="$(echo "$2" | tr 'a-z' 'A-Z')"
16 shift
17 elif [ "$1" = '--level' ]; then
18 export MSGLEVEL=$2
19 shift
68042532
DK
20 else
21 echo >&2 "WARNING: Unknown parameter »$1« will be ignored"
22 fi
23 shift
24done
25export MSGLEVEL="${MSGLEVEL:-3}"
26
8d876415 27# we all like colorful messages
61e92778 28if [ "${MSGCOLOR:-YES}" = 'YES' ]; then
27cb4f6c 29 if [ ! -t 1 ]; then # but check that we output to a terminal
1290422a
DK
30 export MSGCOLOR='NO'
31 fi
32fi
33
1290422a
DK
34if [ "$MSGCOLOR" != 'NO' ]; then
35 CERROR="\033[1;31m" # red
36 CWARNING="\033[1;33m" # yellow
37 CMSG="\033[1;32m" # green
38 CINFO="\033[1;96m" # light blue
39 CDEBUG="\033[1;94m" # blue
40 CNORMAL="\033[0;39m" # default system console color
41 CDONE="\033[1;32m" # green
42 CPASS="\033[1;32m" # green
43 CFAIL="\033[1;31m" # red
44 CCMD="\033[1;35m" # pink
682a3bf7 45fi
8d876415 46
de81b2e2
DK
47msgprintf() {
48 local START="$1"
49 local MIDDLE="$2"
50 local END="$3"
51 shift 3
52 if [ -n "$1" ]; then
53 printf "$START " "$1"
d73840dc 54 shift
de81b2e2 55 while [ -n "$1" ]; do
bc8f83a5 56 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghks]\)#apt-\1#')"
de81b2e2
DK
57 shift
58 done
59 fi
60 printf "${END}"
2a2a7ef4 61}
de81b2e2
DK
62msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
63msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
64msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
65msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
66msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
67msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
68msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
69msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
70msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
71msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
72msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
3c528b91 73msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
1501a2c9 74msgreportheader() {
68042532 75 if [ -n "$MSGTEST_MSG" ]; then
1501a2c9 76 test "$1" != 'msgfailoutput' || echo
ae7fce5a
DK
77 if [ -n "$MSGTEST_MSGMSG" ]; then
78 echo "$MSGTEST_MSGMSG"
79 fi
22ac12b2 80 if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
1501a2c9 81 echo "${CFAIL}Part of the test group: $MSGTEST_GRP"
22ac12b2 82 fi
68042532
DK
83 echo -n "$MSGTEST_MSG"
84 unset MSGTEST_MSG
85 fi
1501a2c9
DK
86}
87msgskip() {
88 msgreportheader 'msgskip'
68ba0b7f
DK
89 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
90 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
91}
5229b285 92msgfail() {
1501a2c9 93 msgreportheader 'msgfail'
68042532 94 if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
3c528b91 95 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
03aa0847 96 if [ -n "$APT_DEBUG_TESTS" ]; then
896f0ae8 97 runapt $SHELL
03aa0847 98 fi
5229b285
DK
99 EXIT_CODE=$((EXIT_CODE+1));
100}
9beb11aa
DK
101MSGGROUP_LEVEL=0
102msggroup() {
103 if [ -n "$1" ]; then
104 if [ $MSGGROUP_LEVEL = 0 ]; then
105 MSGTEST_GRP='NEXT'
106 fi
107 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1));
108 else
109 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1));
110 if [ $MSGGROUP_LEVEL = 0 ]; then
111 unset MSGTEST_GRP
112 fi
113 fi
114}
8d876415
DK
115
116# enable / disable Debugging
fc89263e
DK
117if [ $MSGLEVEL -le 0 ]; then
118 msgdie() { true; }
119fi
120if [ $MSGLEVEL -le 1 ]; then
121 msgwarn() { true; }
122 msgnwarn() { true; }
123fi
124if [ $MSGLEVEL -le 2 ]; then
ae7fce5a
DK
125 msgmsg() {
126 MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")"
127 }
fc89263e 128 msgnmsg() { true; }
9beb11aa
DK
129 msgtest() {
130 MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")"
131 if [ "$MSGTEST_GRP" = 'NEXT' ]; then
132 MSGTEST_GRP="$MSGTEST_MSG"
133 fi
134 }
3c528b91 135 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
fc89263e
DK
136fi
137if [ $MSGLEVEL -le 3 ]; then
138 msginfo() { true; }
139 msgninfo() { true; }
140fi
141if [ $MSGLEVEL -le 4 ]; then
142 msgdebug() { true; }
143 msgndebug() { true; }
144fi
145msgdone() {
146 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
147 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
148 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
149 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
150 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
151 true;
152 else
3c528b91 153 printf "${CDONE}DONE${CNORMAL}\n";
fc89263e
DK
154 fi
155}
e43a426e
MV
156getaptconfig() {
157 if [ -f ./aptconfig.conf ]; then
5465192b 158 echo "$(readlink -f ./aptconfig.conf)"
e43a426e 159 elif [ -f ../aptconfig.conf ]; then
5465192b
DK
160 echo "$(readlink -f ../aptconfig.conf)"
161 elif [ -f ../../aptconfig.conf ]; then
162 echo "$(readlink -f ../../aptconfig.conf)"
163 elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
164 echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
165 fi
e43a426e 166}
8d876415
DK
167runapt() {
168 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
846856f4
DK
169 local CMD="$1"
170 shift
3abb6a6a 171 case "$CMD" in
a311fb96 172 sh|aptitude|*/*|command) ;;
3b8eb3bc
DK
173 *) CMD="${BUILDDIRECTORY}/$CMD";;
174 esac
896f0ae8 175 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH="${LIBRARYPATH}:${LD_LIBRARY_PATH}" "$CMD" "$@"
8d876415 176}
0390edd5 177runpython3() { runapt command python3 "$@"; }
846856f4
DK
178aptconfig() { runapt apt-config "$@"; }
179aptcache() { runapt apt-cache "$@"; }
180aptcdrom() { runapt apt-cdrom "$@"; }
181aptget() { runapt apt-get "$@"; }
dfd863ea 182aptftparchive() { runapt "${APTFTPARCHIVEBINDIR}/apt-ftparchive" "$@"; }
846856f4
DK
183aptkey() { runapt apt-key "$@"; }
184aptmark() { runapt apt-mark "$@"; }
4f6d26b4 185aptsortpkgs() { runapt apt-sortpkgs "$@"; }
796673c3 186apt() { runapt apt "$@"; }
3b8eb3bc
DK
187apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
188aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
189aptitude() { runapt aptitude "$@"; }
8d50b63f 190aptextracttemplates() { runapt apt-extracttemplates "$@"; }
3082603f 191aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
ad7e0941 192aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
8e99b22c 193aptinternalplanner() { runapt "${APTINTERNALPLANNER}" "$@"; }
3b8eb3bc 194
158fda31 195dpkg() {
b0be0e09 196 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
158fda31 197}
ce7f128c 198dpkgcheckbuilddeps() {
63c71412 199 command dpkg-checkbuilddeps --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" "$@"
b6b5a542 200}
3fa950f1 201gdb() {
b07aeb1a
DK
202 local CMD
203 case "$1" in
204 aptget) CMD="apt-get";;
205 aptcache) CMD="apt-cache";;
5465192b
DK
206 aptcdrom) CMD="apt-cdrom";;
207 aptconfig) CMD="apt-config";;
b07aeb1a
DK
208 aptmark) CMD="apt-mark";;
209 apthelper) CMD="apt-helper";;
3d8232bf 210 aptftparchive) CMD="apt-ftparchive";;
63c71412 211 dpkg) shift; runapt "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" "$@"; return;;
b07aeb1a
DK
212 *) CMD="$1";;
213 esac
ce928105 214 shift
921a9626
DK
215 if [ "${CMD##*/}" = "$CMD" ]; then
216 CMD="${BUILDDIRECTORY}/${CMD}"
217 fi
f036d9bb 218 runapt command gdb --quiet -ex "directory '$SOURCEDIRECTORY'" -ex run "$CMD" --args "$CMD" "$@"
ae99ce2e 219}
0340069c 220lastmodification() {
0b45b6e5 221 date -u -d "@$(stat -c '%Y' "${TMPWORKINGDIRECTORY}/$1")" -R
0340069c
DK
222}
223releasefiledate() {
0b45b6e5 224 grep "^${2:-Date}:" "$1" | cut -d' ' -f 2-
0340069c 225}
8d876415 226
8c1dd12c 227exitwithstatus() {
f91bd741
MV
228 # error if we about to overflow, but ...
229 # "255 failures ought to be enough for everybody"
5d76cee1
MV
230 if [ $EXIT_CODE -gt 255 ]; then
231 msgdie "Total failure count $EXIT_CODE too big"
f91bd741 232 fi
5d76cee1 233 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
8c1dd12c
MV
234}
235
804d4a0d
DK
236shellsetedetector() {
237 local exit_status=$?
238 if [ "$exit_status" != '0' ]; then
3c528b91 239 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
804d4a0d
DK
240 if [ "$EXIT_CODE" = '0' ]; then
241 EXIT_CODE="$exit_status"
242 fi
243 fi
244}
245
b720d0bd 246addtrap() {
8437b7d4
DK
247 if [ "$1" = 'prefix' ]; then
248 CURRENTTRAP="$2 $CURRENTTRAP"
249 else
250 CURRENTTRAP="$CURRENTTRAP $1"
251 fi
804d4a0d 252 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
b720d0bd 253}
8d876415 254
bc8f83a5
DK
255escape_shell() {
256 echo "$@" | sed -e "s#'#'\"'\"'#g"
257}
258
61fef4dd
JAK
259find_project_binary_dir() {
260 local TESTDIRECTORY="$(readlink -f "$(dirname $0)")"
261 if [ -z "$PROJECT_BINARY_DIR" ]; then
262 PROJECT_BINARY_DIR=
263 for dir in ${TESTDIRECTORY}/../../ ${TESTDIRECTORY}/../../*; do
264 test -e "$dir/CMakeCache.txt" || continue
265 if [ -z "$PROJECT_BINARY_DIR" ] ||
266 [ "$dir/CMakeCache.txt" -nt "$PROJECT_BINARY_DIR/CMakeCache.txt" ]; then
267 PROJECT_BINARY_DIR="$dir"
268 fi
269 done
270 if [ -z "$PROJECT_BINARY_DIR" ]; then
271 echo "Cannot find build directory, you might want to set PROJECT_BINARY_DIR" >&2
272 exit 1
273 fi
274 export PROJECT_BINARY_DIR
275 fi
276}
8d876415 277setupenvironment() {
14e57111
JAK
278 # Next check needs a gnu stat, let's figure that out early.
279 stat=stat
280 if command -v gnustat >/dev/null 2>&1; then
281 stat=gnustat
282 fi
0d303f17 283 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
14e57111 284 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$($stat --format '%a' "$TMPDIR")" != '1777' ]; then
0d303f17
DK
285 unset TMPDIR
286 fi
63c71412 287 TMPWORKINGDIRECTORY="$(mktemp -d)"
bc8f83a5
DK
288 addtrap "cd /; rm -rf '$(escape_shell "$TMPWORKINGDIRECTORY")';"
289 if [ -n "$TMPDIR_ADD" ]; then
290 TMPWORKINGDIRECTORY="${TMPWORKINGDIRECTORY}/${TMPDIR_ADD}"
291 mkdir -p "$TMPWORKINGDIRECTORY"
292 unset TMPDIR_ADD
293 export TMPDIR="$TMPWORKINGDIRECTORY"
294 fi
63c71412 295 msgninfo "Preparing environment for ${0##*/} in ${TMPWORKINGDIRECTORY}…"
5c0dd6fc 296
14e57111
JAK
297 # Setup coreutils on BSD systems
298 mkdir "${TMPWORKINGDIRECTORY}/bin"
299 for prefix in gnu g; do
300 for command in stat touch sed cp tr sha1sum sha256sum md5sum sha512sum grep date wc chmod head readlink tar expr base64; do
301 if command -v $prefix$command 2>/dev/null >/dev/null; then
302 [ -e "${TMPWORKINGDIRECTORY}/bin/$command" ] || ln -sf $(command -v $prefix$command) "${TMPWORKINGDIRECTORY}/bin/$command"
303 fi
304 done
305 done
306 export PATH="${TMPWORKINGDIRECTORY}/bin/:$PATH"
307
308
03aa0847 309 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
310 if [ "$(id -u)" = '0' ]; then
311 # relax permissions so that running as root with user switching works
312 umask 022
03aa0847
DK
313 chmod 711 "$TMPWORKINGDIRECTORY"
314 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
315 fi
316
63c71412 317 TESTDIRECTORY="$(readlink -f "$(dirname $0)")"
61fef4dd
JAK
318 # Find the newest build directory (sets PROJECT_BINARY_DIR)
319 find_project_binary_dir
5c0dd6fc 320 # allow overriding the default BUILDDIR location
63c71412 321 SOURCEDIRECTORY="${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}"
61fef4dd 322 BUILDDIRECTORY="${APT_INTEGRATION_TESTS_BUILD_DIR:-"${PROJECT_BINARY_DIR}/cmdline"}"
dfd863ea
JAK
323 LIBRARYPATH="${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}/../apt-pkg"}"
324 METHODSDIR="${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/../methods"}"
63c71412 325 APTHELPERBINDIR="${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}"
dfd863ea
JAK
326 APTWEBSERVERBINDIR="${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}/../test/interactive-helper"}"
327 APTFTPARCHIVEBINDIR="${APT_INTEGRATION_TESTS_FTPARCHIVE_BIN_DIR:-"${BUILDDIRECTORY}/../ftparchive"}"
328 APTINTERNALSOLVER="${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/solvers/apt"}"
329 APTDUMPSOLVER="${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/solvers/dump"}"
330 APTINTERNALPLANNER="${APT_INTEGRATION_TESTS_INTERNAL_PLANNER:-"${BUILDDIRECTORY}/planners/apt"}"
8d876415 331 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
5c0dd6fc
MV
332 # -----
333
63c71412 334 cd "$TMPWORKINGDIRECTORY"
cd725954 335 mkdir rootdir aptarchive keys
8d876415 336 cd rootdir
b29c3712 337 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
84255101 338 mkdir -p usr/bin var/cache var/lib var/log var/crash tmp
cffea9af 339 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
b327c569 340 mkdir -p usr/lib/apt/solvers usr/lib/apt/planners
cd725954 341 touch var/lib/dpkg/available
63c71412 342 ln -s "${METHODSDIR}" usr/lib/apt/methods
b327c569
DK
343 ln -s "${APTDUMPSOLVER}" usr/lib/apt/solvers/dump
344 ln -s "${APTDUMPSOLVER}" usr/lib/apt/planners/dump
345 ln -s "${APTINTERNALSOLVER}" usr/lib/apt/solvers/apt
346 ln -s "${APTINTERNALPLANNER}" usr/lib/apt/planners/apt
347 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" >> ../aptconfig.conf
348 echo "Dir::Bin::Planners \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/planners\";" >> ../aptconfig.conf
291a386f
MV
349 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
350 # system
c21dab68
DK
351 if [ -z "${APT_INTEGRATION_TESTS_SOURCE_DIR}" ]; then
352 ln -s "${SOURCEDIRECTORY}/debian/apt.conf.autoremove" etc/apt/apt.conf.d/01autoremove
291a386f
MV
353 else
354 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
355 fi
8d876415 356 cd ..
63c71412
DK
357 local BASENAME="${0##*/}"
358 local PACKAGESFILE="Packages-${BASENAME#*-}"
53ea1b56
DK
359 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
360 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 361 fi
63c71412 362 local SOURCESSFILE="Sources-${BASENAME#*-}"
53ea1b56
DK
363 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
364 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 365 fi
3abb6a6a
DK
366 find "$TESTDIRECTORY" \( -name '*.pub' -o -name '*.sec' \) -exec cp '{}' keys/ \;
367 chmod 644 keys/*
63c71412 368 ln -s "${TMPWORKINGDIRECTORY}/keys/joesixpack.pub" rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
d6cf2345 369
b4f91d4d 370 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
8757a0fd
JAK
371 echo "Dir::Etc \"etc\";" >> aptconfig.conf
372 echo "Dir::State \"var/lib/apt\";" >> aptconfig.conf
373 echo "Dir::Cache \"var/cache/apt\";" >> aptconfig.conf
374 echo "Dir::Etc \"etc/apt\";" >> aptconfig.conf
375 echo "Dir::Log \"var/log/apt\";" >> aptconfig.conf
8d876415 376 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
9d2a8a73 377 echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf
23e64f6d
DK
378 # either store apt-key were we can access it, even if we run it as a different user
379 #cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
380 #chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
381 #echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
382 # destroys coverage reporting though, so we disable changing user for the calling gpgv
383 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
68ba0b7f 384 if [ "$(id -u)" = '0' ]; then
007d8b48
DK
385 echo 'Binary::gpgv::APT::Sandbox::User "root";' >> aptconfig.conf
386 # same for the solver executables
387 echo 'APT::Solver::RunAsUser "root";' >> aptconfig.conf
8e99b22c 388 echo 'APT::Planner::RunAsUser "root";' >> aptconfig.conf
68ba0b7f 389 fi
b0be0e09 390
63c71412 391 cat > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
b0be0e09
DK
392#!/bin/sh
393set -e
3abb6a6a 394if [ -r '${TMPWORKINGDIRECTORY}/noopchroot.so' ]; then
63c71412 395 if [ -n "\$LD_LIBRARY_PATH" ]; then
3abb6a6a 396 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}:'"\${LD_LIBRARY_PATH}"
b0be0e09 397 else
3abb6a6a 398 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}'
b0be0e09 399 fi
921a9626 400 if [ -n "\$LD_PRELOAD" ]; then
63c71412 401 export LD_PRELOAD="noopchroot.so \${LD_PRELOAD}"
921a9626 402 else
63c71412 403 export LD_PRELOAD="noopchroot.so"
921a9626
DK
404 fi
405fi
63c71412
DK
406EOF
407 cp "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
408 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
3abb6a6a 409exec fakeroot '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
f8e8a14f 410 --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" \\
3abb6a6a 411 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
63c71412
DK
412 --force-not-root --force-bad-path "\$@"
413EOF
414 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" <<EOF
3abb6a6a 415exec fakeroot gdb --quiet -ex run '${DPKG:-dpkg}' --args '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
f8e8a14f 416 --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" \\
3abb6a6a 417 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
b0be0e09
DK
418 --force-not-root --force-bad-path "\$@"
419EOF
921a9626 420 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
b0be0e09
DK
421 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
422
533fe3d1
DK
423 {
424 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
425 echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it…
426 fi
87d6947d 427 echo 'quiet "0";'
533fe3d1
DK
428 echo 'quiet::NoUpdate "true";'
429 echo 'quiet::NoStatistic "true";'
430 # too distracting for users, but helpful to detect changes
431 echo 'Acquire::Progress::Ignore::ShowErrorText "true";'
432 echo 'Acquire::Progress::Diffpercent "true";'
433 # in testcases, it can appear as if localhost has a rotation setup,
434 # hide this as we can't really deal with it properly
435 echo 'Acquire::Failure::ShowIP "false";'
ebca2f25
DK
436 # fakeroot can't fake everything, so disabled in production but good for tests
437 echo 'APT::Sandbox::Verify "true";'
533fe3d1 438 } >> aptconfig.conf
d6cf2345 439
68ba0b7f
DK
440 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
441 if [ "$(id -u)" = '0' ]; then
442 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
443 fi
444 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
d6cf2345 445 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
08fcf962 446 export APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=no
23d35ec1 447 echo 'Acquire::Connect::AddrConfig "false";' > rootdir/etc/apt/apt.conf.d/connect-addrconfig
493a813e 448
276e51dd 449 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
51c04562 450 confighashes 'SHA256' # these are tests, not security best-practices
77a45beb 451
4bb006d1 452 # create some files in /tmp and look at user/group to get what this means
eab57e08 453 TEST_DEFAULT_USER="$(id -un)"
71e22da9
JAK
454 touch "${TMPWORKINGDIRECTORY}/test-file"
455 TEST_DEFAULT_GROUP=$(stat --format '%G' "${TMPWORKINGDIRECTORY}/test-file")
4bb006d1 456
ce7f128c 457 # cleanup the environment a bit
995a4bf6 458 # prefer our apt binaries over the system apt binaries
8c617819 459 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
7c1177f6 460 export LC_ALL=C
3b8eb3bc 461 unset LANGUAGE APT_CONFIG
ce7f128c 462 unset GREP_OPTIONS DEB_BUILD_PROFILES
59f57473 463 unset http_proxy HTTP_PROXY https_proxy HTTPS_PROXY no_proxy
0cbb7e29
JAK
464
465 # If gpgv supports --weak-digest, pass it to make sure we can disable SHA1
466 if aptkey verify --weak-digest SHA1 --help 2>/dev/null >/dev/null; then
467 echo 'Acquire::gpgv::Options { "--weak-digest"; "sha1"; };' > rootdir/etc/apt/apt.conf.d/no-sha1
468 fi
469
5a23c56d
DK
470 # most tests just need one signed Release file, not both
471 export APT_DONT_SIGN='Release.gpg'
472
60b48d4f
DK
473 if [ -r "${TESTDIRECTORY}/extra-environment" ]; then
474 . "${TESTDIRECTORY}/extra-environment"
475 fi
476
8d876415
DK
477 msgdone "info"
478}
479
ea65d079
DK
480getarchitecture() {
481 if [ "$1" = "native" -o -z "$1" ]; then
482 eval `aptconfig shell ARCH APT::Architecture`
483 if [ -n "$ARCH" ]; then
484 echo $ARCH
485 else
5834d7a1 486 dpkg --print-architecture
ea65d079
DK
487 fi
488 else
489 echo $1
490 fi
491}
492
53ea1b56 493getarchitectures() {
081c9d44 494 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
53ea1b56
DK
495}
496
3dcdc1f9
DK
497getarchitecturesfromcommalist() {
498 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
499}
500
8d876415 501configarchitecture() {
18908589
DK
502 {
503 echo "APT::Architecture \"$(getarchitecture $1)\";"
504 while [ -n "$1" ]; do
505 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
506 shift
507 done
508 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
53ea1b56
DK
509 configdpkg
510}
511
512configdpkg() {
513 if [ ! -e rootdir/var/lib/dpkg/status ]; then
63c71412
DK
514 local BASENAME="${0##*/}"
515 local STATUSFILE="status-${BASENAME#*-}"
53ea1b56
DK
516 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
517 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
518 else
519 echo -n > rootdir/var/lib/dpkg/status
520 fi
521 fi
18908589 522 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
c5306b16
JAK
523 # if multi-arch make sure dpkg can detect itself as capable of it
524 if getarchitectures | grep -E -q '[^ ]+ [^ ]+'; then
525 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
526 # dpkg doesn't really check the version as long as it is fully installed,
527 # but just to be sure we choose one above the required version
528 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
529 fi
530 fi
846856f4 531 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
53ea1b56 532 local ARCHS="$(getarchitectures)"
87f99f6f
DK
533 local DPKGARCH="$(dpkg --print-architecture)"
534 # this ensures that even if multi-arch isn't active in the view
535 # of apt, given that dpkg can't be told which arch is native
536 # the arch apt treats as native might be foreign for dpkg
537 for ARCH in ${ARCHS}; do
538 if [ "${ARCH}" != "${DPKGARCH}" ]; then
539 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
540 # old-style used e.g. in Ubuntu-P – and as it seems travis
541 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
542 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
feae193b 543 fi
87f99f6f
DK
544 fi
545 done
53ea1b56 546 fi
8d876415
DK
547}
548
0c787570
DK
549configdpkgnoopchroot() {
550 # create a library to noop chroot() and rewrite maintainer script executions
551 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
552 # chroot directory dpkg could chroot into to execute the maintainer scripts
553 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
63c71412 554 cat > noopchroot.c << EOF
0c787570
DK
555#define _GNU_SOURCE
556#include <stdio.h>
557#include <stdlib.h>
558#include <string.h>
559#include <dlfcn.h>
560
561static char * chrootdir = NULL;
562
563int chroot(const char *path) {
564 printf("WARNING: CHROOTing to %s was ignored!\n", path);
565 free(chrootdir);
566 chrootdir = strdup(path);
567 return 0;
568}
569int execvp(const char *file, char *const argv[]) {
570 static int (*func_execvp) (const char *, char * const []) = NULL;
571 if (func_execvp == NULL)
572 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
573 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
574 return func_execvp(file, argv);
575 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
950733c9
JAK
576 char *newfile;
577 if (asprintf(&newfile, "%s%s", chrootdir, file) == -1) {
578 perror("asprintf");
579 return -1;
580 }
b0be0e09 581 char const * const baseadmindir = "/var/lib/dpkg";
950733c9
JAK
582 char *admindir;
583 if (asprintf(&admindir, "%s%s", chrootdir, baseadmindir) == -1) {
584 perror("asprintf");
585 return -1;
586 }
b0be0e09 587 setenv("DPKG_ADMINDIR", admindir, 1);
0c787570
DK
588 return func_execvp(newfile, argv);
589}
590EOF
1a7c66e4
JAK
591 if cc -ldl 2>&1 | grep -q dl; then
592 testempty --nomsg cc -Wall -Wextra -fPIC -shared -o noopchroot.so noopchroot.c
593 else
594 testempty --nomsg cc -Wall -Wextra -fPIC -shared -o noopchroot.so noopchroot.c -ldl
595 fi
0c787570 596}
276e51dd 597configcompression() {
bdc42211
DK
598 if [ "$1" = 'ALL' ]; then
599 configcompression '.' $(aptconfig dump APT::Compressor --format '%t %v%n' | sed -n 's#^Extension \.\(.*\)$#\1#p')
600 return
601 fi
abec2980 602 local CMD='apthelper cat-file -C'
276e51dd
DK
603 while [ -n "$1" ]; do
604 case "$1" in
3c528b91 605 '.') printf ".\t.\tcat\n";;
abec2980
DK
606 'gz') printf "gzip\tgz\t$CMD $1\n";;
607 'bz2') printf "bzip2\tbz2\t$CMD $1\n";;
608 *) printf "$1\t$1\t$CMD $1\n";;
276e51dd
DK
609 esac
610 shift
63c71412 611 done > "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf"
276e51dd 612}
c5ede4ca
DK
613confighashes() {
614 {
615 echo 'APT::FTPArchive {'
616 {
617 while [ -n "$1" ]; do
618 printf "$1" | tr 'a-z' 'A-Z'
619 printf "\t\"true\";\n"
620 shift
621 done
622 for h in 'MD5' 'SHA1' 'SHA256' 'SHA512'; do
623 printf "$h\t\"false\";\n"
624 done
625 } | awk '!x[$1]++'
626 echo '};'
627 } >> "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/ftparchive-hashes.conf"
628}
5f982b9d
DK
629forcecompressor() {
630 COMPRESSOR="$1"
912a6131 631 COMPRESS="$1"
abec2980 632 COMPRESSOR_CMD="apthelper cat-file -C $1"
5f982b9d
DK
633 case $COMPRESSOR in
634 gzip) COMPRESS='gz';;
635 bzip2) COMPRESS='bz2';;
5f982b9d
DK
636 esac
637 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
638 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
912a6131 639Dir::Bin::uncompressed \"/does/not/exist\";" > "$CONFFILE"
b2fd8524
DK
640 for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do
641 if [ -z "$COMP" -o "$COMP" = '.' -o "$COMP" = "$COMPRESSOR" ]; then continue; fi
642 echo "Dir::Bin::${COMP} \"/does/not/exist\";" >> "$CONFFILE"
643 echo "APT::Compressor::${COMP}::Name \"${COMP}-disabled\";" >> "$CONFFILE"
644 done
5f982b9d
DK
645}
646
b8242321 647_setupsimplenativepackage() {
75954ae2
DK
648 local NAME="$1"
649 local ARCH="$2"
650 local VERSION="$3"
651 local RELEASE="${4:-unstable}"
652 local DEPENDENCIES="$5"
34f0d758 653 local DESCRIPTION="${6:-an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
654 If you find such a package installed on your system,
655 something went horribly wrong! They are autogenerated
34f0d758 656 und used only by testcases and serve no other purpose…}"
18908589 657
75954ae2 658 local SECTION="${7:-others}"
d67004e0 659 local PRIORITY="${8:-optional}"
63c71412
DK
660 local FILE_TREE="$9"
661 local COMPRESS_TYPE="${10:-gzip}"
75954ae2 662 local DISTSECTION
63c71412 663 if [ "$SECTION" = "${SECTION#*/}" ]; then
75954ae2
DK
664 DISTSECTION="main"
665 else
63c71412 666 DISTSECTION="${SECTION%/*}"
75954ae2 667 fi
63c71412 668 local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}"
b761356f 669
63c71412
DK
670 mkdir -p "$BUILDDIR/debian/source"
671 echo "* most suckless software product ever" > "${BUILDDIR}/FEATURES"
b761356f 672 echo "#!/bin/sh
63c71412 673echo '$NAME says \"Hello!\"'" > "${BUILDDIR}/${NAME}"
b761356f 674
0340069c 675 echo "Copyleft by Joe Sixpack $(date -u +%Y)" > "${BUILDDIR}/debian/copyright"
b761356f
DK
676 echo "$NAME ($VERSION) $RELEASE; urgency=low
677
678 * Initial release
679
0340069c 680 -- Joe Sixpack <joe@example.org> $(date -u -R)" > "${BUILDDIR}/debian/changelog"
63c71412
DK
681 {
682 echo "Source: $NAME
d67004e0 683Priority: $PRIORITY
b761356f 684Maintainer: Joe Sixpack <joe@example.org>
63c71412
DK
685Standards-Version: 3.9.3"
686 if [ "$SECTION" != '<none>' ]; then
687 echo "Section: $SECTION"
688 fi
76325a66 689 local BUILDDEPS="$(printf "%b\n" "$DEPENDENCIES" | grep '^Build-')"
63c71412
DK
690 test -z "$BUILDDEPS" || echo "$BUILDDEPS"
691 echo "
692Package: $NAME"
b761356f 693
63c71412
DK
694 if [ "$ARCH" = 'all' ]; then
695 echo "Architecture: all"
696 else
697 echo "Architecture: any"
698 fi
76325a66 699 local DEPS="$(printf "%b\n" "$DEPENDENCIES" | grep -v '^Build-')"
63c71412 700 test -z "$DEPS" || echo "$DEPS"
76325a66 701 printf "%b\n" "Description: $DESCRIPTION"
63c71412 702 } > "${BUILDDIR}/debian/control"
01f520ce 703
63c71412 704 echo '3.0 (native)' > "${BUILDDIR}/debian/source/format"
b8242321
DK
705}
706
4b1fb7b1
JAK
707make_tiny_rules() {
708 local OUT="$1"
709 if command -v gmake >/dev/null 2>&1; then
710 [ -e ${TMPWORKINGDIRECTORY}/bin/make ] || ln -s $(command -v gmake) ${TMPWORKINGDIRECTORY}/bin/make
711 echo "#!${TMPWORKINGDIRECTORY}/bin/make -f" > "$OUT"
712 else
713 echo '#!/usr/bin/make -f' > "$OUT"
714 fi
715 echo '%:' >> "$OUT"
716 echo ' dh $@' >> "$OUT"
717}
718
b8242321
DK
719setupsimplenativepackage() {
720 _setupsimplenativepackage "$@"
721 local NAME="$1"
722 local VERSION="$3"
723 local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}"
724 test -e "${BUILDDIR}/debian/compat" || echo '7' > "${BUILDDIR}/debian/compat"
4b1fb7b1 725 test -e "${BUILDDIR}/debian/rules" || make_tiny_rules "${BUILDDIR}/debian/rules"
b8242321
DK
726}
727
728buildsimplenativepackage() {
729 local NAME="$1"
730 local ARCH="$2"
731 local VERSION="$3"
732 local RELEASE="${4:-unstable}"
733 local DEPENDENCIES="$5"
734 local DESCRIPTION="$6"
735 local SECTION="${7:-others}"
736 local PRIORITY="${8:-optional}"
737 local FILE_TREE="$9"
738 local COMPRESS_TYPE="${10:-gzip}"
739 local DISTSECTION
740 if [ "$SECTION" = "${SECTION#*/}" ]; then
741 DISTSECTION="main"
742 else
743 DISTSECTION="${SECTION%/*}"
744 fi
745 local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}"
746 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
747 _setupsimplenativepackage "$@"
63c71412 748 cd "${BUILDDIR}/.."
0c787570
DK
749 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
750 cd - >/dev/null
63c71412 751 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" \
f1828b69 752 | while read SRC; do
63c71412 753 echo "pool/${SRC}" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist"
f1828b69 754# if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
33a22672 755# aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
bd7fb5aa 756# adv --yes --default-key 'Joe Sixpack' \
f1828b69
DK
757# --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
758# mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
759# fi
b761356f 760 done
84aa13f4 761
3dcdc1f9 762 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
0c787570 763 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
63c71412
DK
764 rm -rf "${BUILDDIR}/debian/tmp"
765 mkdir -p "${BUILDDIR}/debian/tmp/DEBIAN" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin"
766 cp "${BUILDDIR}/debian/copyright" "${BUILDDIR}/debian/changelog" "${BUILDDIR}/FEATURES" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}"
767 cp "${BUILDDIR}/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}"
42c1513b 768 if [ -n "$FILE_TREE" ]; then
63c71412 769 cp -ar "$FILE_TREE" "${BUILDDIR}/debian/tmp"
42c1513b 770 fi
42c1513b 771
63c71412
DK
772 (cd "${BUILDDIR}"; dpkg-gencontrol -DArchitecture=$arch)
773 (cd "${BUILDDIR}/debian/tmp"; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
846856f4 774 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
d56e2917 775 # ensure the right permissions as dpkg-deb insists
63c71412
DK
776 chmod 755 "${BUILDDIR}/debian/tmp/DEBIAN"
777 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build "${BUILDDIR}/debian/tmp" "${BUILDDIR}/.."
778 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist"
84aa13f4
DK
779 done
780
b8242321
DK
781 local NM
782 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then
783 NM="$(echo "$NAME" | cut -c 1-4)"
784 else
785 NM="$(echo "$NAME" | cut -c 1)"
786 fi
d56e2917 787 local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
63c71412
DK
788 mkdir -p "$CHANGEPATH"
789 cp "${BUILDDIR}/debian/changelog" "$CHANGEPATH"
5a635ee4 790 rm -rf "${BUILDDIR}"
b761356f 791 msgdone "info"
75954ae2
DK
792}
793
794buildpackage() {
795 local BUILDDIR=$1
796 local RELEASE=$2
797 local SECTION=$3
ea65d079 798 local ARCH=$(getarchitecture $4)
846856f4
DK
799 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
800 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
0c787570 801 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
63c71412 802 cd "$BUILDDIR"
75954ae2
DK
803 if [ "$ARCH" = "all" ]; then
804 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
805 fi
0c787570 806 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
63c71412
DK
807 cp "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$BUILDLOG"
808 local PKGS="$(grep '^dpkg-deb: building package' "$BUILDLOG" | cut -d'/' -f 2 | sed -e "s#'\.##")"
809 local SRCS="$(grep '^dpkg-source: info: building' "$BUILDLOG" | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 810 cd - > /dev/null
b7899b00 811 for PKG in $PKGS; do
63c71412 812 echo "pool/${PKG}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist"
b7899b00
DK
813 done
814 for SRC in $SRCS; do
63c71412 815 echo "pool/${SRC}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist"
b7899b00 816 done
ce9864a8
DK
817}
818
819buildaptarchive() {
ce9864a8 820 if [ -d incoming ]; then
846856f4 821 buildaptarchivefromincoming "$@"
ce9864a8 822 else
846856f4 823 buildaptarchivefromfiles "$@"
ce9864a8
DK
824 fi
825}
826
827createaptftparchiveconfig() {
63c71412 828 local COMPRESSORS="$(cut -d' ' -f 1 "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | tr '\n' ' ')"
016bea82
DK
829 local COMPRESSORS="${COMPRESSORS%* }"
830 local ARCHS="$(getarchitectures)"
c5ede4ca
DK
831 cat > ftparchive.conf <<EOF
832Dir {
833 ArchiveDir "$(readlink -f .)";
834 CacheDir "$(readlink -f ..)";
835 FileListDir "$(readlink -f pool/)";
b7899b00
DK
836};
837Default {
c5ede4ca
DK
838 Packages::Compress "$COMPRESSORS";
839 Sources::Compress "$COMPRESSORS";
840 Contents::Compress "$COMPRESSORS";
841 Translation::Compress "$COMPRESSORS";
18331adf 842 LongDescription "false";
ce9864a8
DK
843};
844TreeDefault {
845 Directory "pool/";
846 SrcDirectory "pool/";
847};
c5ede4ca 848EOF
b7899b00 849 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
63c71412
DK
850 cat <<EOF
851tree "dists/$DIST" {
1dd20368 852 Architectures "$ARCHS all source";
63c71412
DK
853 FileList "${DIST}.\$(SECTION).pkglist";
854 SourceFileList "${DIST}.\$(SECTION).srclist";
855 Sections "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')";
856};
857EOF
858 done >> ftparchive.conf
ce9864a8
DK
859}
860
861buildaptftparchivedirectorystructure() {
b7899b00
DK
862 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
863 for DIST in $DISTS; do
864 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
865 for SECTION in $SECTIONS; do
866 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
867 for ARCH in $ARCHS; do
63c71412 868 mkdir -p "dists/${DIST}/${SECTION}/binary-${ARCH}"
b7899b00 869 done
63c71412
DK
870 mkdir -p "dists/${DIST}/${SECTION}/source"
871 mkdir -p "dists/${DIST}/${SECTION}/i18n"
b7899b00 872 done
ce9864a8 873 done
ce9864a8
DK
874}
875
9b78cda6 876insertpackage() {
10e100e5 877 local RELEASES="$1"
9b78cda6
DK
878 local NAME="$2"
879 local ARCH="$3"
880 local VERSION="$4"
881 local DEPENDENCIES="$5"
d67004e0 882 local PRIORITY="${6:-optional}"
34f0d758 883 local DESCRIPTION="${7:-an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
18908589
DK
884 If you find such a package installed on your system,
885 something went horribly wrong! They are autogenerated
34f0d758 886 und used only by testcases and serve no other purpose…}"
d67004e0 887 local ARCHS=""
10e100e5
DK
888 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
889 if [ "$RELEASE" = 'installed' ]; then
890 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
891 continue
d67004e0 892 fi
10e100e5 893 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
1dd20368 894 if [ "$arch" = 'none' ]; then
10e100e5
DK
895 ARCHS="$(getarchitectures)"
896 else
897 ARCHS="$arch"
898 fi
899 for BUILDARCH in $ARCHS; do
900 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
63c71412
DK
901 mkdir -p "$PPATH"
902 {
903 echo "Package: $NAME
d67004e0 904Priority: $PRIORITY
9b78cda6 905Section: other
2c085486 906Installed-Size: 42
63c71412
DK
907Maintainer: Joe Sixpack <joe@example.org>"
908 test "$arch" = 'none' || echo "Architecture: $arch"
909 echo "Version: $VERSION
910Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb"
76325a66 911 test -z "$DEPENDENCIES" || printf "%b\n" "$DEPENDENCIES"
63c71412
DK
912 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)"
913 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)"
914 echo
915 } >> "${PPATH}/Packages"
10e100e5 916 done
d67004e0 917 done
63c71412
DK
918 mkdir -p "aptarchive/dists/${RELEASE}/main/source" "aptarchive/dists/${RELEASE}/main/i18n"
919 touch "aptarchive/dists/${RELEASE}/main/source/Sources"
10e100e5 920 echo "Package: $NAME
0e0d9919
DK
921Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
922Description-en: $DESCRIPTION
63c71412 923" >> "aptarchive/dists/${RELEASE}/main/i18n/Translation-en"
10e100e5 924 done
9b78cda6
DK
925}
926
234675b7 927insertsource() {
07aca07a 928 local RELEASES="$1"
234675b7
DK
929 local NAME="$2"
930 local ARCH="$3"
931 local VERSION="$4"
932 local DEPENDENCIES="$5"
07aca07a 933 local BINARY="${6:-$NAME}"
234675b7 934 local ARCHS=""
07aca07a
DK
935 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
936 local SPATH="aptarchive/dists/${RELEASE}/main/source"
937 mkdir -p $SPATH
938 local FILE="${SPATH}/Sources"
939 local DSCFILE="${NAME}_${VERSION}.dsc"
940 local TARFILE="${NAME}_${VERSION}.tar.gz"
941 echo "Package: $NAME
a8275acf 942Binary: $BINARY
234675b7
DK
943Version: $VERSION
944Maintainer: Joe Sixpack <joe@example.org>
945Architecture: $ARCH" >> $FILE
76325a66 946 test -z "$DEPENDENCIES" || printf "%b\n" "$DEPENDENCIES" >> "$FILE"
07aca07a 947 echo "Files:
63c71412
DK
948 $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
949 $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
55ae7a51 950Checksums-Sha256:
63c71412
DK
951 $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
952 $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
953" >> "$FILE"
07aca07a 954 done
234675b7
DK
955}
956
dfc2b1be
DK
957insertinstalledpackage() {
958 local NAME="$1"
959 local ARCH="$2"
960 local VERSION="$3"
961 local DEPENDENCIES="$4"
d67004e0 962 local PRIORITY="${5:-optional}"
d4b4e5ea 963 local STATUS="${6:-install ok installed}"
34f0d758 964 local DESCRIPTION="${7:-an autogenerated dummy ${NAME}=${VERSION}/installed
18908589
DK
965 If you find such a package installed on your system,
966 something went horribly wrong! They are autogenerated
34f0d758 967 und used only by testcases and serve no other purpose…}"
18908589 968
53ea1b56
DK
969 local FILE='rootdir/var/lib/dpkg/status'
970 local INFO='rootdir/var/lib/dpkg/info'
3dcdc1f9 971 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
d67004e0 972 echo "Package: $NAME
d4b4e5ea 973Status: $STATUS
d67004e0 974Priority: $PRIORITY
dfc2b1be
DK
975Section: other
976Installed-Size: 42
977Maintainer: Joe Sixpack <joe@example.org>
63c71412
DK
978Version: $VERSION" >> "$FILE"
979 test "$arch" = 'none' || echo "Architecture: $arch" >> "$FILE"
76325a66
JAK
980 test -z "$DEPENDENCIES" || printf "%b\n" "$DEPENDENCIES" >> "$FILE"
981 printf "%b\n" "Description: $DESCRIPTION" >> "$FILE"
63c71412 982 echo >> "$FILE"
53ea1b56 983 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
63c71412 984 echo -n > "${INFO}/${NAME}:${arch}.list"
53ea1b56 985 else
63c71412 986 echo -n > "${INFO}/${NAME}.list"
53ea1b56 987 fi
d67004e0 988 done
dfc2b1be
DK
989}
990
991
ce9864a8 992buildaptarchivefromincoming() {
63c71412 993 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on incoming packages…"
ce9864a8
DK
994 cd aptarchive
995 [ -e pool ] || ln -s ../incoming pool
996 [ -e ftparchive.conf ] || createaptftparchiveconfig
997 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 998 msgninfo "\tGenerate Packages, Sources and Contents files… "
31be38d2 999 testsuccess aptftparchive generate ftparchive.conf
ce9864a8
DK
1000 cd - > /dev/null
1001 msgdone "info"
4dbfe436 1002 generatereleasefiles "$@"
ce9864a8
DK
1003}
1004
1005buildaptarchivefromfiles() {
63c71412 1006 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on prebuild files…"
8d041b4f
DK
1007 local DIR='aptarchive'
1008 if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi
1009 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
9b78cda6 1010 msgninfo "\t${line} file… "
276e51dd 1011 compressfile "$line" "$1"
8d876415 1012 msgdone "info"
9b78cda6 1013 done
e3c62328 1014 generatereleasefiles "$@"
9b78cda6
DK
1015}
1016
276e51dd 1017compressfile() {
bdc42211 1018 while read compressor extension command; do
276e51dd
DK
1019 if [ "$compressor" = '.' ]; then
1020 if [ -n "$2" ]; then
1021 touch -d "$2" "$1"
1022 fi
1023 continue
1024 fi
1025 cat "$1" | $command > "${1}.${extension}"
1026 if [ -n "$2" ]; then
1027 touch -d "$2" "${1}.${extension}"
1028 fi
bdc42211 1029 done < "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf"
276e51dd
DK
1030}
1031
a3bbbab7 1032# can be overridden by testcases for their pleasure
bf9e7447
DK
1033getcodenamefromsuite() {
1034 case "$1" in
1035 unstable) echo 'sid';;
1036 *) echo -n "$1";;
1037 esac
1038}
a3bbbab7 1039getreleaseversionfromsuite() { true; }
718f797c 1040getlabelfromsuite() { true; }
d56e2917 1041getoriginfromsuite() { true; }
1dd20368 1042getarchitecturesfromreleasefile() { echo "all $(getarchitectures)"; }
a3bbbab7 1043
c5ede4ca
DK
1044aptftparchiverelease() {
1045 aptftparchive -qq release "$@" | sed -e '/0 Release$/ d' # remove the self reference
1046}
9b78cda6 1047generatereleasefiles() {
884a4c0a
DK
1048 # $1 is the Date header and $2 is the ValidUntil header to be set
1049 # both should be given in notation date/touch can understand
1dd20368
DK
1050 local DATE="$1"
1051 local VALIDUNTIL="$2"
9b78cda6 1052 if [ -e aptarchive/dists ]; then
87d6947d 1053 msgninfo "\tGenerate Release files for dists… "
9b78cda6 1054 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
1dd20368 1055 local ARCHITECTURES="$(getarchitecturesfromreleasefile "$dir")"
a3bbbab7
DK
1056 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
1057 local CODENAME="$(getcodenamefromsuite $SUITE)"
1058 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 1059 local LABEL="$(getlabelfromsuite $SUITE)"
d56e2917 1060 local ORIGIN="$(getoriginfromsuite $SUITE)"
63c71412 1061 aptftparchiverelease "$dir" \
884a4c0a
DK
1062 -o APT::FTPArchive::Release::Suite="${SUITE}" \
1063 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
bc7a59dd
DK
1064 -o APT::FTPArchive::Release::Architectures="${ARCHITECTURES}" \
1065 -o APT::FTPArchive::Release::Label="${LABEL}" \
1066 -o APT::FTPArchive::Release::Origin="${ORIGIN}" \
1067 -o APT::FTPArchive::Release::Version="${VERSION}" \
63c71412 1068 > "$dir/Release"
a3bbbab7 1069 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11 1070 sed -i '/^Date: / a\
63c71412 1071NotAutomatic: yes' "$dir/Release"
35faae11 1072 fi
9b78cda6
DK
1073 done
1074 else
87d6947d 1075 msgninfo "\tGenerate Release files for flat… "
c5ede4ca 1076 aptftparchiverelease ./aptarchive > aptarchive/Release
8d876415 1077 fi
1dd20368 1078 if [ -n "$DATE" -a "$DATE" != "now" ]; then
fe0f7911 1079 for release in $(find ./aptarchive -name 'Release'); do
0b45b6e5 1080 sed -i "s/^Date: .*$/Date: $(date -u -d "$DATE" -R)/" "$release"
1dd20368 1081 touch -d "$DATE" "$release"
fe0f7911 1082 done
8d876415 1083 fi
1dd20368 1084 if [ -n "$VALIDUNTIL" ]; then
c5ede4ca 1085 sed -i "/^Date: / a\
0b45b6e5 1086Valid-Until: $(date -u -d "$VALIDUNTIL" -R)" $(find ./aptarchive -name 'Release')
c5ede4ca 1087 fi
b7899b00 1088 msgdone "info"
8d876415
DK
1089}
1090
b7899b00 1091setupdistsaptarchive() {
63c71412 1092 local APTARCHIVE="$(readlink -f ./aptarchive | sed 's# #%20#g')"
b7899b00
DK
1093 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
1094 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
1095 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
63c71412 1096 SECTIONS=$(find "./aptarchive/dists/${DISTS}/" -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
b7899b00 1097 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
63c71412
DK
1098 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list"
1099 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list"
b7899b00
DK
1100 msgdone "info"
1101 done
1102}
1103
1104setupflataptarchive() {
63c71412
DK
1105 local APTARCHIVE="$(readlink -f ./aptarchive)"
1106 local APTARCHIVEURI="$(readlink -f ./aptarchive | sed 's# #%20#g')"
1107 if [ -f "${APTARCHIVE}/Packages" ]; then
8d876415 1108 msgninfo "\tadd deb sources.list line… "
63c71412
DK
1109 echo "deb file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
1110 msgdone 'info'
8d876415 1111 else
63c71412 1112 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
8d876415 1113 fi
63c71412 1114 if [ -f "${APTARCHIVE}/Sources" ]; then
8d876415 1115 msgninfo "\tadd deb-src sources.list line… "
63c71412
DK
1116 echo "deb-src file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
1117 msgdone 'info'
8d876415 1118 else
63c71412 1119 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
8d876415 1120 fi
b7899b00
DK
1121}
1122
1123setupaptarchive() {
4dbfe436
DK
1124 local NOUPDATE=0
1125 if [ "$1" = '--no-update' ]; then
1126 NOUPDATE=1
1127 shift
1128 fi
1129 buildaptarchive "$@"
b7899b00
DK
1130 if [ -e aptarchive/dists ]; then
1131 setupdistsaptarchive
1132 else
1133 setupflataptarchive
1134 fi
9d653a6d 1135 signreleasefiles 'Joe Sixpack'
4dbfe436 1136 if [ "1" != "$NOUPDATE" ]; then
5684f71f 1137 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
b2ea1a47 1138 fi
8d876415
DK
1139}
1140
f213b6ea 1141signreleasefiles() {
fb7b11eb 1142 local SIGNERS="${1:-Joe Sixpack}"
07cb47e7 1143 local REPODIR="${2:-aptarchive}"
1af227c2
DK
1144 if [ -n "$1" ]; then shift; fi
1145 if [ -n "$1" ]; then shift; fi
fb7b11eb
DK
1146 local KEY="keys/$(echo "$SIGNERS" | tr 'A-Z' 'a-z' | tr -d ' ,')"
1147 msgninfo "\tSign archive with $SIGNERS key $KEY… "
29a59c46
DK
1148 local REXKEY='keys/rexexpired'
1149 local SECEXPIREBAK="${REXKEY}.sec.bak"
1150 local PUBEXPIREBAK="${REXKEY}.pub.bak"
fb7b11eb
DK
1151 local SIGUSERS=""
1152 while [ -n "${SIGNERS%%,*}" ]; do
1153 local SIGNER="${SIGNERS%%,*}"
1154 if [ "${SIGNERS}" = "${SIGNER}" ]; then
1155 SIGNERS=""
1156 fi
1157 SIGNERS="${SIGNERS#*,}"
1158 # FIXME: This should be the full name, but we can't encode the space properly currently
1159 SIGUSERS="${SIGUSERS} -u ${SIGNER#* }"
1160 if [ "${SIGNER}" = 'Rex Expired' ]; then
1161 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
1162 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
1163 # therefore we 'temporary' make the key not expired and restore a backup after signing
1164 cp "${REXKEY}.sec" "$SECEXPIREBAK"
1165 cp "${REXKEY}.pub" "$PUBEXPIREBAK"
1166 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
1167 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
1168 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
1169 cp "$SECUNEXPIRED" "${REXKEY}.sec"
1170 cp "$PUBUNEXPIRED" "${REXKEY}.pub"
1171 else
1172 if ! printf "expire\n1w\nsave\n" | aptkey --quiet --keyring "${REXKEY}.pub" --secret-keyring "${REXKEY}.sec" \
1173 --readonly adv --batch --yes --digest-algo "${APT_TESTS_DIGEST_ALGO:-SHA512}" \
1174 --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
1175 cat setexpire.gpg
1176 exit 1
1177 fi
1178 cp "${REXKEY}.sec" "$SECUNEXPIRED"
1179 cp "${REXKEY}.pub" "$PUBUNEXPIRED"
f1e1abd8 1180 fi
29a59c46 1181 fi
fb7b11eb
DK
1182 if [ ! -e "${KEY}.pub" ]; then
1183 local K="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | tr -d ' ,')"
1184 cat "${K}.pub" >> "${KEY}.new.pub"
1185 cat "${K}.sec" >> "${KEY}.new.sec"
1186 fi
1187 done
1188 if [ ! -e "${KEY}.pub" ]; then
1189 mv "${KEY}.new.pub" "${KEY}.pub"
1190 mv "${KEY}.new.sec" "${KEY}.sec"
29a59c46 1191 fi
fb7b11eb 1192 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes --digest-algo ${APT_TESTS_DIGEST_ALGO:-SHA512}"
63c71412 1193 for RELEASE in $(find "${REPODIR}/" -name Release); do
e3c62328 1194 # we might have set a specific date for the Release file, so copy it
761a5ad2
DK
1195 local DATE="$(stat --format "%y" "${RELEASE}")"
1196 if [ "$APT_DONT_SIGN" = 'Release.gpg' ]; then
1197 rm -f "${RELEASE}.gpg"
1198 else
1199 testsuccess $GPG "$@" $SIGUSERS --armor --detach-sign --sign --output "${RELEASE}.gpg" "${RELEASE}"
1200 touch -d "$DATE" "${RELEASE}.gpg"
1201 fi
1202 local INRELEASE="${RELEASE%/*}/InRelease"
1203 if [ "$APT_DONT_SIGN" = 'InRelease' ]; then
1204 rm -f "$INRELEASE"
1205 else
1206 testsuccess $GPG "$@" $SIGUSERS --clearsign --output "$INRELEASE" "$RELEASE"
1207 touch -d "$DATE" "${INRELEASE}"
1208 fi
f213b6ea 1209 done
29a59c46 1210 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
63c71412
DK
1211 mv -f "$SECEXPIREBAK" "${REXKEY}.sec"
1212 mv -f "$PUBEXPIREBAK" "${REXKEY}.pub"
29a59c46 1213 fi
63c71412 1214 msgdone 'info'
f213b6ea
DK
1215}
1216
8eafc759 1217redatereleasefiles() {
0b45b6e5 1218 local DATE="$(date -u -d "$1" -R)"
8eafc759 1219 for release in $(find aptarchive/ -name 'Release'); do
63c71412
DK
1220 sed -i "s/^Date: .*$/Date: ${DATE}/" "$release"
1221 touch -d "$DATE" "$release"
8eafc759
DK
1222 done
1223 signreleasefiles "${2:-Joe Sixpack}"
1224}
1225
f2c0ec8b 1226webserverconfig() {
6c0765c0 1227 local WEBSERVER="${3:-http://localhost:${APTHTTPPORT}}"
b0314abb
DK
1228 local NOCHECK=false
1229 if [ "$1" = '--no-check' ]; then
1230 NOCHECK=true
1231 shift
1232 fi
0d58c26a 1233 local DOWNLOG='rootdir/tmp/download-testfile.log'
b0314abb 1234 local STATUS='downloaded/webserverconfig.status'
0d58c26a 1235 rm -f "$STATUS" "$DOWNLOG"
6c0765c0 1236 # very very basic URI encoding
b0314abb
DK
1237 local URI
1238 if [ -n "$2" ]; then
1239 msgtest "Set webserver config option '${1}' to" "$2"
6c0765c0 1240 URI="${WEBSERVER}/_config/set/$(echo "${1}" | sed -e 's/\//%2f/g')/$(echo "${2}" | sed -e 's/\//%2f/g')"
b0314abb
DK
1241 else
1242 msgtest 'Clear webserver config option' "${1}"
6c0765c0 1243 URI="${WEBSERVER}/_config/clear/$(echo "${1}" | sed -e 's/\//%2f/g')"
b0314abb
DK
1244 fi
1245 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
f2c0ec8b
DK
1246 msgpass
1247 else
68042532
DK
1248 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output"
1249 cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true
1250 msgfailoutput '' "$OUTPUT"
f2c0ec8b 1251 fi
b0314abb 1252 $NOCHECK || testwebserverlaststatuscode '200'
f2c0ec8b
DK
1253}
1254
fd46d305 1255rewritesourceslist() {
63c71412 1256 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
af9e40c9 1257 local APTARCHIVE2="copy://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
fd46d305 1258 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
af9e40c9 1259 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#$APTARCHIVE2#${1}#" \
28b2efcb
DK
1260 -e "s#http://[^@]*@\?localhost:${APTHTTPPORT}/\?#${1}#" \
1261 -e "s#https://[^@]*@\?localhost:${APTHTTPSPORT}/\?#${1}#"
fd46d305
DK
1262 done
1263}
1264
5572f6bd
MV
1265# wait for up to 10s for a pid file to appear to avoid possible race
1266# when a helper is started and dosn't write the PID quick enough
1267waitforpidfile() {
1268 local PIDFILE="$1"
1269 for i in $(seq 10); do
1270 if test -s "$PIDFILE"; then
1271 return 0
1272 fi
1273 sleep 1
1274 done
1275 msgdie "waiting for $PIDFILE failed"
1276 return 1
1277}
1278
f213b6ea 1279changetowebserver() {
6c0765c0 1280 local REWRITE='no'
23af9f40 1281 if [ "$1" != '--no-rewrite' ]; then
6c0765c0 1282 REWRITE='yes'
23af9f40
DK
1283 else
1284 shift
1285 fi
63c71412 1286 if test -x "${APTWEBSERVERBINDIR}/aptwebserver"; then
fbd29dd6 1287 cd aptarchive
a0db467c 1288 local LOG="webserver.log"
6c0765c0 1289 if ! aptwebserver --port 0 -o aptwebserver::fork=1 -o aptwebserver::portfile='aptwebserver.port' "$@" >$LOG 2>&1 ; then
3abb6a6a 1290 cat "$LOG"
bee0670b
DK
1291 false
1292 fi
6c0765c0 1293 waitforpidfile aptwebserver.pid
e3c62328
DK
1294 local PID="$(cat aptwebserver.pid)"
1295 if [ -z "$PID" ]; then
1296 msgdie 'Could not fork aptwebserver successfully'
1297 fi
1298 addtrap "kill $PID;"
6c0765c0
DK
1299 waitforpidfile aptwebserver.port
1300 APTHTTPPORT="$(cat aptwebserver.port)"
1301 if [ -z "$APTHTTPPORT" ]; then
1302 msgdie 'Could not get port for aptwebserver successfully'
1303 fi
fbd29dd6 1304 cd - > /dev/null
c5bcc607 1305 else
3d284148 1306 msgdie 'You have to build apt from source to have test/interactive-helper/aptwebserver available for tests requiring a webserver'
f213b6ea 1307 fi
6c0765c0
DK
1308 if [ "$REWRTE" != 'yes' ]; then
1309 rewritesourceslist "http://localhost:${APTHTTPPORT}/"
1310 fi
fd46d305
DK
1311}
1312
1313changetohttpswebserver() {
144ce920
JAK
1314 local stunnel4
1315 if command -v stunnel4 >/dev/null 2>&1; then
1316 stunnel4=stunnel4
1317 elif command -v stunnel >/dev/null 2>&1; then
1318 stunnel4=stunnel
1319 else
fd46d305
DK
1320 msgdie 'You need to install stunnel4 for https testcases'
1321 fi
1322 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
dc95fee1 1323 changetowebserver --no-rewrite "$@"
fd46d305
DK
1324 fi
1325 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
68ba0b7f 1326cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
23af9f40 1327output = /dev/null
fd46d305
DK
1328
1329[https]
6c0765c0
DK
1330accept = 0
1331connect = $APTHTTPPORT
63c71412 1332" > "${TMPWORKINGDIRECTORY}/stunnel.conf"
144ce920 1333 $stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
5572f6bd 1334 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
63c71412 1335 local PID="$(cat "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid")"
5572f6bd 1336 if [ -z "$PID" ]; then
144ce920 1337 msgdie 'Could not fork $stunnel4 successfully'
5572f6bd 1338 fi
fd46d305 1339 addtrap 'prefix' "kill ${PID};"
144ce920 1340 APTHTTPSPORT="$(lsof -i -n | awk "/^$stunnel4 / && \$2 == \"${PID}\" {print \$9; exit; }" | cut -d':' -f 2)"
6c0765c0
DK
1341 webserverconfig 'aptwebserver::port::https' "$APTHTTPSPORT" "https://localhost:${APTHTTPSPORT}"
1342 rewritesourceslist "https://localhost:${APTHTTPSPORT}/"
f213b6ea
DK
1343}
1344
c45233ea
DK
1345changetocdrom() {
1346 mkdir -p rootdir/media/cdrom/.disk
1347 local CD="$(readlink -f rootdir/media/cdrom)"
63c71412
DK
1348 cat > rootdir/etc/apt/apt.conf.d/00cdrom <<EOF
1349acquire::cdrom::mount "${CD}";
1350acquire::cdrom::"${CD}/"::mount "mv ${CD}-unmounted ${CD}";
1351acquire::cdrom::"${CD}/"::umount "mv ${CD} ${CD}-unmounted";
1352acquire::cdrom::autodetect 0;
1353EOF
1354 echo -n "$1" > "${CD}/.disk/info"
c45233ea
DK
1355 if [ ! -d aptarchive/dists ]; then
1356 msgdie 'Flat file archive cdroms can not be created currently'
1357 return 1
1358 fi
a0975c8d 1359 mv aptarchive/dists "$CD"
63c71412 1360 ln -s "$(readlink -f ./incoming)" "$CD/pool"
c45233ea 1361 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
a0975c8d
DK
1362 # start with an unmounted disk
1363 mv "${CD}" "${CD}-unmounted"
1364 # we don't want the disk to be modifiable
bc8f83a5 1365 addtrap 'prefix' "chmod -f -R +w '$(escape_shell "$PWD/rootdir/media/cdrom/dists/")' '$(escape_shell "$PWD/rootdir/media/cdrom-unmounted/dists/")' || true;"
b0314abb 1366 chmod -R 555 rootdir/media/cdrom-unmounted/dists
c45233ea
DK
1367}
1368
fd46d305 1369downloadfile() {
ed793a19 1370 local PROTO="${1%%:*}"
27925d82 1371 if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
dcbb364f 1372 download-file "$1" "$2" "$3" 2>&1 ; then
27925d82
DK
1373 return 1
1374 fi
fd46d305 1375 # only if the file exists the download was successful
b0314abb 1376 if [ -r "$2" ]; then
fd46d305
DK
1377 return 0
1378 else
1379 return 1
1380 fi
1381}
1382
f213b6ea 1383checkdiff() {
03aa0847 1384 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
8d876415 1385 if [ -n "$DIFFTEXT" ]; then
0d58c26a
DK
1386 echo >&2
1387 echo >&2 "$DIFFTEXT"
8d876415
DK
1388 return 1
1389 else
1390 return 0
1391 fi
1392}
1393
22ac12b2
DK
1394testoutputequal() {
1395 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output"
1396 local COMPAREFILE="$1"
1397 shift
63c71412 1398 if "$@" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then
22ac12b2
DK
1399 msgpass
1400 else
1401 echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}"
1402 cat "$COMPAREFILE" >>"${OUTPUT}"
1403 msgfailoutput '' "$OUTPUT" "$@"
1404 fi
1405}
1406
75954ae2 1407testfileequal() {
1501a2c9 1408 msggroup 'testfileequal'
e6a12ff7
DK
1409 local MSG='Test for correctness of file'
1410 if [ "$1" = '--nomsg' ]; then
1411 MSG=''
1412 shift
1413 fi
75954ae2
DK
1414 local FILE="$1"
1415 shift
e6a12ff7
DK
1416 if [ -n "$MSG" ]; then
1417 msgtest "$MSG" "$FILE"
1418 fi
68042532 1419 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output"
75954ae2 1420 if [ -z "$*" ]; then
22ac12b2 1421 testoutputequal "$FILE" echo -n ''
75954ae2 1422 else
22ac12b2 1423 testoutputequal "$FILE" echo "$*"
75954ae2 1424 fi
9beb11aa 1425 msggroup
75954ae2
DK
1426}
1427
b855a400 1428testempty() {
1501a2c9 1429 msggroup 'testempty'
a66e1837
DK
1430 if [ "$1" = '--nomsg' ]; then
1431 shift
1432 else
1433 msgtest "Test for no output of" "$*"
1434 fi
859093da 1435 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
a66e1837 1436 if "$@" >"$COMPAREFILE" 2>&1 && test ! -s "$COMPAREFILE"; then
859093da
DK
1437 msgpass
1438 else
22ac12b2 1439 msgfailoutput '' "$COMPAREFILE" "$@"
859093da 1440 fi
ab25bf1f 1441 aptautotest 'testempty' "$@"
9beb11aa 1442 msggroup
b855a400 1443}
63c71412
DK
1444testnotempty() {
1445 msggroup 'testnotempty'
1446 msgtest "Test for some output of" "$*"
1447 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnotempty.comparefile"
1448 if ("$@" >"$COMPAREFILE" 2>&1 || true) && test -s "$COMPAREFILE"; then
1449 msgpass
1450 else
1451 msgfailoutput '' "$COMPAREFILE" "$@"
1452 fi
1453 aptautotest 'testnotempty' "$@"
1454 msggroup
1455}
b855a400 1456
f74a6fa1 1457testequal() {
1501a2c9 1458 msggroup 'testequal'
f74a6fa1
DK
1459 local MSG='Test of equality of'
1460 if [ "$1" = '--nomsg' ]; then
1461 MSG=''
1462 shift
1463 fi
1464
03938280 1465 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
63c71412 1466 echo "$1" > "$COMPAREFILE"
8d876415 1467 shift
d2d68aaf 1468
f74a6fa1
DK
1469 if [ -n "$MSG" ]; then
1470 msgtest "$MSG" "$*"
1471 fi
22ac12b2 1472 testoutputequal "$COMPAREFILE" "$@"
ab25bf1f 1473 aptautotest 'testequal' "$@"
9beb11aa 1474 msggroup
8d876415
DK
1475}
1476
685625bd 1477testequalor2() {
1501a2c9 1478 msggroup 'testequalor2'
03938280
DK
1479 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1480 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1481 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
63c71412
DK
1482 echo "$1" > "$COMPAREFILE1"
1483 echo "$2" > "$COMPAREFILE2"
685625bd
DK
1484 shift 2
1485 msgtest "Test for equality OR of" "$*"
63c71412
DK
1486 "$@" >"$COMPAREAGAINST" 2>&1 || true
1487 if checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >/dev/null 2>&1 || \
1488 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >/dev/null 2>&1
0d58c26a 1489 then
0caa5a4c
DK
1490 msgpass
1491 else
68042532
DK
1492 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
1493 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1
1494 checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1495 echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1
1496 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1497 msgfailoutput '' "$OUTPUT"
0caa5a4c 1498 fi
ab25bf1f 1499 aptautotest 'testequalor2' "$@"
9beb11aa 1500 msggroup
685625bd
DK
1501}
1502
8d876415 1503testshowvirtual() {
1501a2c9 1504 msggroup 'testshowvirtual'
edc0ef10 1505 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1506 local PACKAGE="$1"
1507 shift
1508 while [ -n "$1" ]; do
1509 VIRTUAL="${VIRTUAL}
edc0ef10 1510N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1511 PACKAGE="${PACKAGE} $1"
1512 shift
1513 done
1514 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1515 VIRTUAL="${VIRTUAL}
4bec02c2 1516N: No packages found"
03938280 1517 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
ea65d079 1518 local ARCH="$(getarchitecture 'native')"
68042532
DK
1519 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE"
1520 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output"
87d6947d 1521 testoutputequal "$COMPAREFILE" aptcache show "$PACKAGE"
9beb11aa 1522 msggroup
8d876415
DK
1523}
1524
1525testnopackage() {
1501a2c9 1526 msggroup 'testnopackage'
8d876415 1527 msgtest "Test for non-existent packages" "apt-cache show $*"
846856f4 1528 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
8d876415 1529 if [ -n "$SHOWPKG" ]; then
68042532
DK
1530 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1531 echo "$SHOWPKG" >"$OUTPUT"
1532 msgfailoutput '' "$OUTPUT"
0d58c26a
DK
1533 else
1534 msgpass
8d876415 1535 fi
9beb11aa 1536 msggroup
8d876415 1537}
bd4a8f51
DK
1538testnosrcpackage() {
1539 msggroup 'testnosrcpackage'
1540 msgtest "Test for non-existent source packages" "apt-cache showsrc $*"
1541 local SHOWPKG="$(aptcache showsrc "$@" 2>&1 | grep '^Package: ')"
1542 if [ -n "$SHOWPKG" ]; then
1543 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnosrcpackage.output"
1544 echo "$SHOWPKG" >"$OUTPUT"
1545 msgfailoutput '' "$OUTPUT"
1546 else
1547 msgpass
1548 fi
1549 msggroup
1550}
01a6e24c 1551
ecb777dd 1552testdpkgstatus() {
1501a2c9 1553 msggroup 'testdpkgstatus'
ecb777dd
DK
1554 local STATE="$1"
1555 local NR="$2"
1556 shift 2
1557 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1558 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1559 if [ "$PKGS" != $NR ]; then
68042532
DK
1560 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1561 echo "$PKGS" >"$OUTPUT"
1562 dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true
1563 msgfailoutput '' "$OUTPUT"
0d58c26a
DK
1564 else
1565 msgpass
01a6e24c 1566 fi
9beb11aa 1567 msggroup
01a6e24c
DK
1568}
1569
ecb777dd 1570testdpkginstalled() {
1501a2c9 1571 msggroup 'testdpkginstalled'
ecb777dd 1572 testdpkgstatus 'ii' "$#" "$@"
9beb11aa 1573 msggroup
ecb777dd
DK
1574}
1575
5cf733e1 1576testdpkgnotinstalled() {
1501a2c9 1577 msggroup 'testdpkgnotinstalled'
ecb777dd 1578 testdpkgstatus 'ii' '0' "$@"
9beb11aa 1579 msggroup
01a6e24c 1580}
ec7f904e
DK
1581
1582testmarkedauto() {
1501a2c9 1583 msggroup 'testmarkedauto'
03938280 1584 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
ec7f904e
DK
1585 if [ -n "$1" ]; then
1586 msgtest 'Test for correctly marked as auto-installed' "$*"
63c71412 1587 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
ec7f904e
DK
1588 else
1589 msgtest 'Test for correctly marked as auto-installed' 'no package'
63c71412 1590 echo -n > "$COMPAREFILE"
ec7f904e 1591 fi
22ac12b2 1592 testoutputequal "$COMPAREFILE" aptmark showauto
9beb11aa 1593 msggroup
ec7f904e 1594}
7c2cc4a7 1595testmarkedmanual() {
1501a2c9 1596 msggroup 'testmarkedmanual'
7c2cc4a7
DK
1597 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile"
1598 if [ -n "$1" ]; then
1599 msgtest 'Test for correctly marked as manually installed' "$*"
63c71412 1600 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
7c2cc4a7
DK
1601 else
1602 msgtest 'Test for correctly marked as manually installed' 'no package'
63c71412 1603 echo -n > "$COMPAREFILE"
7c2cc4a7 1604 fi
22ac12b2 1605 testoutputequal "$COMPAREFILE" aptmark showmanual
9beb11aa 1606 msggroup
7c2cc4a7 1607}
89a1aa5d 1608
742f67ea
DK
1609catfile() {
1610 if [ "${1##*.}" = 'deb' ]; then
1611 stat >&2 "$1" || true
1612 file >&2 "$1" || true
1613 else
1614 cat >&2 "$1" || true
1615 fi
1616}
e52aad52 1617msgfailoutput() {
1501a2c9 1618 msgreportheader 'msgfailoutput'
e52aad52
DK
1619 local MSG="$1"
1620 local OUTPUT="$2"
1621 shift 2
b4f91d4d
DK
1622 local CMD="$1"
1623 if [ "$1" = 'grep' -o "$1" = 'tail' -o "$1" = 'head' ]; then
68042532 1624 echo >&2
e52aad52
DK
1625 while [ -n "$2" ]; do shift; done
1626 echo "#### Complete file: $1 ####"
742f67ea 1627 catfile "$1"
b4f91d4d 1628 echo "#### $CMD output ####"
e52aad52 1629 elif [ "$1" = 'test' ]; then
68042532 1630 echo >&2
e52aad52
DK
1631 # doesn't support ! or non-file flags
1632 msgfailoutputstatfile() {
1633 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1634 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1635 echo "#### stat(2) of file: $2 ####"
1636 stat "$2" || true
dffc17ba
DK
1637 if test -d "$2"; then
1638 echo "#### The directory contains: $2 ####"
1639 ls >&2 "$2" || true
1640 elif test -e "$2"; then
3196dae8 1641 echo "#### Complete file: $2 ####"
742f67ea 1642 catfile "$2"
3196dae8 1643 fi
e52aad52
DK
1644 fi
1645 }
1646 msgfailoutputstatfile "$2" "$3"
1647 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1648 shift 3
1649 msgfailoutputstatfile "$2" "$3"
1650 done
1651 echo '#### test output ####'
6fc2e030
DK
1652 elif [ "$1" = 'cmp' ]; then
1653 echo >&2
1654 while [ -n "$2" ]; do
1655 echo "#### Complete file: $2 ####"
742f67ea 1656 catfile "$2"
6fc2e030
DK
1657 shift
1658 done
1659 echo '#### cmp output ####'
e52aad52 1660 fi
742f67ea 1661 catfile "$OUTPUT"
e52aad52
DK
1662 msgfail "$MSG"
1663}
1664
671a55ba
DK
1665testsuccesswithglobalerror() {
1666 local TYPE="$1"
1667 local ERRORS="$2"
1668 shift 2
1669 msggroup "$TYPE"
0440d936
DK
1670 if [ "$1" = '--nomsg' ]; then
1671 shift
1672 else
1673 msgtest 'Test for successful execution of' "$*"
1674 fi
671a55ba 1675 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/${TYPE}.output"
63c71412 1676 if "$@" >"${OUTPUT}" 2>&1; then
4fa34122 1677 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1678 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1679 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
671a55ba 1680 elif grep -E "^[${ERRORS}]: " "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then
3261271e
DK
1681 if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then
1682 if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \
1683 | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then
1684 msgpass
1685 else
1686 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1687 fi
1688 else
1689 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1690 fi
671a55ba
DK
1691 elif [ "$TYPE" = 'testsuccesswithnotice' ]; then
1692 if grep -q -E "^N: " "$OUTPUT"; then
1693 msgpass
1694 else
1695 msgfailoutput 'successful run, but output had no notices' "$OUTPUT" "$@"
1696 fi
4fa34122
DK
1697 else
1698 msgpass
1699 fi
1700 else
1701 msgpass
1702 fi
1703 else
1704 local EXITCODE=$?
e52aad52 1705 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
4fa34122 1706 fi
671a55ba 1707 aptautotest "$TYPE" "$@"
9beb11aa 1708 msggroup
4fa34122 1709}
671a55ba
DK
1710testsuccesswithnotice() {
1711 testsuccesswithglobalerror 'testsuccesswithnotice' 'WE' "$@"
1712}
1713testsuccess() {
1714 testsuccesswithglobalerror 'testsuccess' 'NWE' "$@"
1715}
4fa34122 1716testwarning() {
1501a2c9 1717 msggroup 'testwarning'
4fa34122
DK
1718 if [ "$1" = '--nomsg' ]; then
1719 shift
1720 else
1721 msgtest 'Test for successful execution with warnings of' "$*"
1722 fi
25b86db1 1723 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
63c71412 1724 if "$@" >"${OUTPUT}" 2>&1; then
1df24acf 1725 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1726 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1727 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1728 elif grep -q -E '^E: ' "$OUTPUT"; then
1729 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
4fa34122 1730 elif ! grep -q -E '^W: ' "$OUTPUT"; then
e52aad52 1731 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1df24acf
DK
1732 else
1733 msgpass
1734 fi
1735 else
1736 msgpass
1737 fi
0440d936 1738 else
07cb47e7 1739 local EXITCODE=$?
68042532 1740 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
0440d936 1741 fi
4fa34122 1742 aptautotest 'testwarning' "$@"
9beb11aa 1743 msggroup
0440d936 1744}
0440d936 1745testfailure() {
1501a2c9 1746 msggroup 'testfailure'
0440d936
DK
1747 if [ "$1" = '--nomsg' ]; then
1748 shift
1749 else
889b0072 1750 msgtest 'Test for failure in execution of' "$*"
0440d936 1751 fi
03938280 1752 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
63c71412 1753 if "$@" >"${OUTPUT}" 2>&1; then
07cb47e7 1754 local EXITCODE=$?
e52aad52 1755 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
0440d936 1756 else
1df24acf
DK
1757 local EXITCODE=$?
1758 if expr match "$1" '^apt.*' >/dev/null; then
b0d40854 1759 if [ "$1" = 'aptkey' ]; then
2fac0dd5
DK
1760 if grep -q " Can't check signature:
1761 BAD signature from
1762 signature could not be verified" "$OUTPUT"; then
b0d40854
DK
1763 msgpass
1764 else
1765 msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
1766 fi
1df24acf 1767 else
b0d40854
DK
1768 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1769 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1770 elif grep -q -E '==ERROR' "$OUTPUT"; then
1771 msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
1772 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1773 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1774 else
1775 msgpass
1776 fi
1df24acf
DK
1777 fi
1778 else
1779 msgpass
1780 fi
0440d936 1781 fi
ab25bf1f 1782 aptautotest 'testfailure' "$@"
9beb11aa 1783 msggroup
0440d936
DK
1784}
1785
7414af7f
DK
1786testreturnstateequal() {
1787 local STATE="$1"
671a55ba
DK
1788 if [ "$STATE" = 'testsuccesswithglobalerror' ]; then
1789 local STATE="$2"
1790 local TYPE="$3"
7414af7f 1791 shift 3
671a55ba
DK
1792 msggroup "${STATE}equal"
1793 if [ "$1" != '--nomsg' ]; then
1794 local CMP="$1"
1795 shift
1796 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1797 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1798 else
1799 local CMP="$2"
1800 shift 2
1801 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1802 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1803 fi
1804 else
1805 msggroup "${STATE}equal"
1806 if [ "$2" != '--nomsg' ]; then
1807 local CMP="$2"
1808 shift 2
1809 "$STATE" "$@"
1810 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1811 else
1812 local CMP="$3"
1813 shift 3
1814 "$STATE" --nomsg "$@"
1815 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1816 fi
7414af7f 1817 fi
9beb11aa 1818 msggroup
25b86db1 1819}
7414af7f 1820testsuccessequal() {
671a55ba
DK
1821 # we compare output, so we know perfectly well about N:
1822 testreturnstateequal 'testsuccesswithglobalerror' 'testsuccess' 'WE' "$@"
7414af7f 1823}
25b86db1 1824testwarningequal() {
7414af7f 1825 testreturnstateequal 'testwarning' "$@"
25b86db1
DK
1826}
1827testfailureequal() {
7414af7f 1828 testreturnstateequal 'testfailure' "$@"
25b86db1
DK
1829}
1830
27925d82 1831testfailuremsg() {
1501a2c9 1832 msggroup 'testfailuremsg'
27925d82
DK
1833 local CMP="$1"
1834 shift
1835 testfailure "$@"
1836 msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
68042532 1837 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile"
002b1bc4 1838 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true
22ac12b2 1839 testoutputequal "$COMPAREFILE" echo "$CMP"
9beb11aa 1840 msggroup
27925d82 1841}
f18f2338
DK
1842testwarningmsg() {
1843 msggroup 'testwarningmsg'
1844 local CMP="$1"
1845 shift
1846 testwarning "$@"
1847 msgtest 'Check that the output of the previous warned command has expected' 'warnings'
1848 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarningmsg.comparefile"
002b1bc4 1849 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" > "$COMPAREFILE" 2>&1 || true
f18f2338
DK
1850 testoutputequal "$COMPAREFILE" echo "$CMP"
1851 msggroup
1852}
25b86db1 1853
de81b2e2 1854testfilestats() {
1501a2c9 1855 msggroup 'testfilestats'
de81b2e2
DK
1856 msgtest "Test that file $1 has $2 $3" "$4"
1857 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
5684f71f
DK
1858 msgpass
1859 else
68042532
DK
1860 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output"
1861 {
1862 ls -ld "$1" || true
1863 echo -n "stat(1) reports for $2: "
1864 stat --format "$2" "$1" || true
1865 } >"$OUTPUT" 2>&1
1866 msgfailoutput '' "$OUTPUT"
5684f71f 1867 fi
9beb11aa 1868 msggroup
5684f71f 1869}
de81b2e2 1870testaccessrights() {
1501a2c9 1871 msggroup 'testaccessrights'
de81b2e2 1872 testfilestats "$1" '%a' '=' "$2"
9beb11aa 1873 msggroup
de81b2e2 1874}
5684f71f 1875
0d58c26a 1876testwebserverlaststatuscode() {
1501a2c9 1877 msggroup 'testwebserverlaststatuscode'
0d58c26a 1878 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
03aa0847 1879 local STATUS='downloaded/webserverstatus-statusfile.log'
0d58c26a
DK
1880 rm -f "$DOWNLOG" "$STATUS"
1881 msgtest 'Test last status code from the webserver was' "$1"
6c0765c0 1882 if downloadfile "http://localhost:${APTHTTPPORT}/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
0d58c26a
DK
1883 msgpass
1884 else
68042532
DK
1885 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output"
1886 {
1887 if [ -n "$2" ]; then
1888 shift
1889 echo >&2 '#### Additionally provided output files contain:'
1890 cat >&2 "$@"
1891 fi
1892 echo >&2 '#### Download log of the status code:'
1893 cat >&2 "$DOWNLOG"
1894 } >"$OUTPUT" 2>&1
1895 msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT"
0d58c26a 1896 fi
9beb11aa 1897 msggroup
0d58c26a
DK
1898}
1899
19fdf93d 1900mapkeynametokeyid() {
785cb6fc 1901 while [ -n "$1" ]; do
19fdf93d
DK
1902 case "$1" in
1903 *Joe*|*Sixpack*|newarchive) echo '5A90D141DBAC8DAE';;
1904 *Rex*|*Expired*) echo '4BC0A39C27CE74F9';;
1905 *Marvin*|*Paranoid*) echo 'E8525D47528144E2';;
1906 oldarchive) echo 'FDD2DB85F68C85A3';;
1907 *) echo 'UNKNOWN KEY';;
1908 esac
785cb6fc
DK
1909 shift
1910 done
1911}
1912testaptkeys() {
1913 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/aptkeylist.output"
19fdf93d 1914 if ! aptkey list --with-colon | grep '^pub' | cut -d':' -f 5 > "$OUTPUT"; then
785cb6fc
DK
1915 echo -n > "$OUTPUT"
1916 fi
19fdf93d 1917 testfileequal "$OUTPUT" "$(mapkeynametokeyid "$@")"
785cb6fc
DK
1918}
1919
89a1aa5d
DK
1920pause() {
1921 echo "STOPPED execution. Press enter to continue"
1922 local IGNORE
1923 read IGNORE
1924}
ab25bf1f 1925
34651385
DK
1926logcurrentarchivedirectory() {
1927 find "${TMPWORKINGDIRECTORY}/aptarchive/dists" -type f | while read line; do
1928 stat --format '%U:%G:%a:%n' "$line"
1929 done | sort > "${TMPWORKINGDIRECTORY}/rootdir/var/log/aptgetupdate.before.lst"
1930}
846bc058 1931listcurrentlistsdirectory() {
ba6b79bd
DK
1932 {
1933 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1934 stat --format '%U:%G:%a:%n' "$line"
1935 done
1936 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1937 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1938 done
1939 } | sort
846bc058 1940}
912a6131 1941forallsupportedcompressors() {
b2fd8524 1942 rm -f "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
912a6131 1943 for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do
0179cfa8 1944 if [ -z "$COMP" -o "$COMP" = '.' ]; then continue; fi
912a6131
DK
1945 "$@" "$COMP"
1946 done
1947}
846bc058 1948
3a8776a3 1949### convenience hacks ###
8fe964f1
DK
1950mkdir() {
1951 # creating some directories by hand is a tedious task, so make it look simple
6aef1942
DK
1952 local PARAMS="$*"
1953 if [ "$PARAMS" != "${PARAMS#*rootdir/var/lib/apt/lists}" ]; then
8fe964f1
DK
1954 # only the last directory created by mkdir is effected by the -m !
1955 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1956 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1957 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1958 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1959 if [ "$(id -u)" = '0' ]; then
1960 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1961 fi
1962 else
1963 command mkdir "$@"
1964 fi
1965}
1966
ab25bf1f
DK
1967### The following tests are run by most test methods automatically to check
1968### general things about commands executed without writing the test every time.
1969
1970aptautotest() {
c1e202d2 1971 if [ $# -lt 3 ]; then return; fi
ab25bf1f
DK
1972 local TESTCALL="$1"
1973 local CMD="$2"
1974 local FIRSTOPT="$3"
c1e202d2
DK
1975 shift 2
1976 for i in "$@"; do
1977 if ! expr match "$i" '^-' >/dev/null 2>&1; then
1978 FIRSTOPT="$i"
1979 break
1980 fi
1981 done
1982 shift
896f0ae8 1983 local AUTOTEST="aptautotest_$(echo "${CMD##*/}_${FIRSTOPT}" | tr -d -c 'A-za-z0-9')"
ab25bf1f 1984 if command -v $AUTOTEST >/dev/null; then
ab25bf1f
DK
1985 # save and restore the *.output files from other tests
1986 # as we might otherwise override them in these automatic tests
63c71412
DK
1987 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1988 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1989 mkdir "${TMPWORKINGDIRECTORY}/rootdir/tmp"
ab25bf1f 1990 $AUTOTEST "$TESTCALL" "$@"
63c71412
DK
1991 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1992 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1993 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" "${TMPWORKINGDIRECTORY}/rootdir/tmp"
ab25bf1f
DK
1994 fi
1995}
1996
1997aptautotest_aptget_update() {
59148d96
DK
1998 local TESTCALL="$1"
1999 while [ -n "$2" ]; do
2000 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
2001 shift
2002 done
ab25bf1f 2003 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
4bb006d1
DK
2004 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
2005 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
ab25bf1f 2006 # all copied files are properly chmodded
63c71412
DK
2007 local backupIFS="$IFS"
2008 IFS="$(printf "\n\b")"
146f7715 2009 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
4bb006d1 2010 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
ab25bf1f 2011 done
63c71412 2012 IFS="$backupIFS"
59148d96 2013 if [ "$TESTCALL" = 'testsuccess' ]; then
146f7715
DK
2014 # failure cases can retain partial files and such
2015 testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \)
2016 fi
34651385
DK
2017 if [ -s "${TMPWORKINGDIRECTORY}/rootdir/var/log/aptgetupdate.before.lst" ]; then
2018 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/var/log/aptgetupdate.before.lst" \
2019 "$(find "${TMPWORKINGDIRECTORY}/aptarchive/dists" -type f | while read line; do stat --format '%U:%G:%a:%n' "$line"; done | sort)"
2020 fi
ab25bf1f
DK
2021}
2022aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
d84da499 2023aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; }
016bea82
DK
2024
2025testaptautotestnodpkgwarning() {
2026 local TESTCALL="$1"
2027 while [ -n "$2" ]; do
6bf93605
DK
2028 if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode
2029 if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode
016bea82
DK
2030 shift
2031 done
2032 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
2033}
2034
2035aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
2036aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
2037aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
2038aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
2039aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
2040aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }
e5c3f3cc
DK
2041
2042testaptmarknodefaultsections() {
2043 testfailure grep '^Auto-Installed: 0$' "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/extended_states"
2044}
2045aptautotest_aptmark_auto() { testaptmarknodefaultsections "$@"; }
2046aptautotest_aptmark_manual() { testaptmarknodefaultsections "$@"; }
2047aptautotest_aptget_markauto() { testaptmarknodefaultsections "$@"; }
2048aptautotest_aptget_markmanual() { testaptmarknodefaultsections "$@"; }